#!/usr/bin/env python
# -*- coding: UTF8 -*-

# Python module gnome_connection_manager.py
# Autogenerated from gnome-connection-manager.glade
# Generated on Thu Aug  6 18:11:29 2009

# Warning: Do not modify any context comment such as #--
# They are required to keep user's code

#TODO: 
# - soportar telnet??
# - ventana de configuracion
# - colores de letras

import os
import operator
import sys
import base64
import time

try:
  import gtk
  import gobject
except:
  print >> sys.stderr, "Debes instalar pygtk"
  sys.exit(1)
  
  
try:
  import vte
except:
  error = gtk.MessageDialog (None, gtk.DIALOG_MODAL, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK,
    'Debes instalar libvte para python')
  error.run()
  sys.exit (1)
  
  
from SimpleGladeApp import SimpleGladeApp
from SimpleGladeApp import bindtextdomain

import ConfigParser

SSH_COMMAND = "/usr/share/gnome-connection-manager/ssh.expect"
CONFIG_FILE = os.getenv("HOME") + "/.gcm/gcm.conf"

if not os.path.exists(os.getenv("HOME") + "/.gcm"):
    os.makedirs(os.getenv("HOME") + "/.gcm")

app_name = "Gnome Connection Manager"
app_version = "0.4.0"
app_web = "http://www.kuthulu.com/gcm"


HSPLIT = 0
VSPLIT = 1

glade_dir = ""
locale_dir = ""

bindtextdomain(app_name, locale_dir)

groups={}

#Variables de configuracion
class conf():
    WORD_SEPARATORS="-A-Za-z0-9,./?%&#:_=+@~"
    BUFFER_LINES=2000
    CONFIRM_ON_EXIT=True
    FONT_COLOR = ""
    BACK_COLOR = ""

def msgbox(text):
    msgBox = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_ERROR, gtk.BUTTONS_OK, text)
    msgBox.set_icon_from_file("/usr/share/gnome-connection-manager/icon.png")
    msgBox.run()
    msgBox.destroy()  

def msgconfirm(text):
    msgBox = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_QUESTION, gtk.BUTTONS_OK_CANCEL, text)
    msgBox.set_icon_from_file("/usr/share/gnome-connection-manager/icon.png")
    response = msgBox.run()    
    msgBox.destroy()
    return response


## funciones para encryptar passwords - no son muy seguras, pero impiden que los pass se guarden en texto plano
def xor(pw, str1):
    c = 0
    liste = []
    for k in xrange(len(str1)):
        if c > len(pw)-1:
            c = 0
        fi = ord(pw[c])
        c += 1
        se = ord(str1[k])
        fin = operator.xor(fi, se)
        liste += [chr(fin)]
    return liste
        
def encrypt(passw, string):
    try:
        ret = xor(passw, string)    
        s = base64.b64encode("".join(ret))
    except:
        s = ""
    return s
 
def decrypt(passw, string):
    try:
        ret = xor(passw, base64.b64decode(string))
        s = "".join(ret)
    except:
        s = ""
    return s
    
    
    

class Wmain(SimpleGladeApp):

    def __init__(self, path="gnome-connection-manager.glade",
                 root="wMain",
                 domain=app_name, **kwargs):
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)
        
        self.initLeftPane()     
        global wMain
        wMain = self
        self.get_widget("wMain").maximize()
        self.nbConsole.set_scrollable(True)
        self.nbConsole.set_group_id(11)
        self.nbConsole.connect('page_removed', self.on_page_removed)        
        self.nbConsole.connect("page-added", self.on_page_added)
        
    #-- Wmain.new {
    def new(self):        
        self.hpMain = self.get_widget("hpMain")
        self.nbConsole = self.get_widget("nbConsole")
        self.treeServers = self.get_widget("treeServers")
        self.current = None
        self.count = 0
    #-- Wmain.new }

    #-- Wmain custom methods {
    #   Write your own methods here
     
    def addTab(self, notebook, title, host, user, password, port, tunnel):
        try:
            if len(user)==0:
                user = os.getenv("USERNAME")
            if len(user)==0:
                user = os.getlogin()
            v = vte.Terminal()
            v.set_word_chars(conf.WORD_SEPARATORS)
            v.set_scrollback_lines(conf.BUFFER_LINES)
            
            if len(conf.FONT_COLOR)>0 and len(conf.BACK_COLOR)>0:
                v.set_colors(gtk.gdk.Color(conf.FONT_COLOR), gtk.gdk.Color(conf.BACK_COLOR), [])
                
            scrollPane = gtk.ScrolledWindow()            
            tab = NotebookTabLabel(title, self.nbConsole, scrollPane )
            
            v.connect("child-exited", lambda widget: tab.mark_tab_as_closed())
            v.connect('focus', self.on_tab_focus)
            
            scrollPane.show()
            scrollPane.add(v)
            v.show()
            
            notebook.append_page(scrollPane, tab_label=tab)            
            notebook.set_current_page(self.nbConsole.page_num(scrollPane))  
            notebook.set_tab_reorderable(scrollPane, True)
            notebook.set_tab_detachable(scrollPane, True)
            self.wMain.set_focus(v)
            self.on_tab_focus(v)
                        
            if len(host)==0:
                v.fork_command("bash")
            else:
                args = [SSH_COMMAND, '-l', user, '-p', port]
                for t in tunnel.split(","):
                    if t!="":
                        args.append("-L")
                        args.append(t)
                args.append(host)                
                v.fork_command(SSH_COMMAND, args) 
                while gtk.events_pending():
                    gtk.main_iteration(False)
                    
                #esperar 2 seg antes de enviar el pass para dar tiempo a que se levante expect y prevenir que se muestre el pass
                gobject.timeout_add(2000, self.send_pass, v, password)
        except: 
            msgbox("Error al conectar con servidor: %s" % (sys.exc_info()[1]))
    
    def send_pass(self, terminal, password):        
        terminal.feed_child('%s\r' % (password))
        return False
        
    def initLeftPane(self):
        global groups       

        self.treeModel = gtk.TreeStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gtk.gdk.Pixbuf)
        self.treeServers.set_model(self.treeModel)
        column = gtk.TreeViewColumn("", gtk.CellRendererPixbuf(), pixbuf=6)
        column.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)        
        self.treeServers.append_column( column )
        column = gtk.TreeViewColumn("Servidores", gtk.CellRendererText(), text=0)
        self.treeServers.append_column( column )        
        
        self.loadConfig()
        self.updateTree()
        
        
    def loadConfig(self):
        global groups
        
        cp= ConfigParser.RawConfigParser( )
        cp.read( CONFIG_FILE )
        
        #Leer configuracion general
        try:
            conf.WORD_SEPARATORS = cp.get("options", "word-separators")
            conf.BUFFER_LINES = cp.getint("options", "buffer-lines")
            conf.CONFIRM_ON_EXIT = cp.getboolean("options", "confirm-exit")
            conf.FONT_COLOR = cp.get("options", "font-color")
            conf.BACK_COLOR = cp.get("options", "back-color")
        except:
            print "Entrada invalida en archivo de configuracion: %s" % (sys.exc_info()[1])
        
        #Leer lista de hosts        
        groups={}        
        for section in cp.sections():
            if not section.startswith("host "):
                continue
            host = cp.options(section)
            try:
                grp = cp.get(section, "group")
                if not groups.has_key(grp):                    
                    groups[grp]=[]         
                try:
                    port = cp.get(section, "port")
                except:                        
                    port = "22"
                try:
                    tunnel = cp.get(section, "tunnel")
                except:                        
                    tunnel = ""
                
                groups[grp].append( { "name": cp.get(section, "name"), "host": cp.get(section, "host"), "user": cp.get(section, "user"), "pass": decrypt(os.getenv("USERNAME"), cp.get(section, "pass")), "port": port, "tunnel": tunnel } )
            except:                
                print "Entrada invalida en archivo de configuracion: %s" % (sys.exc_info()[1])

    def updateTree(self):
        self.treeModel.clear()         
        iconHost = self.treeServers.render_icon("gtk-network", size=gtk.ICON_SIZE_BUTTON, detail=None)
        iconDir = self.treeServers.render_icon("gtk-directory", size=gtk.ICON_SIZE_BUTTON, detail=None)             
        
        grupos = groups.keys()
        grupos.sort()
        for grupo in grupos:
            group = self.treeModel.append(None, [grupo, '', '', '', '', '', iconDir])
            groups[grupo].sort(key=operator.itemgetter('name'))
            for host in groups[grupo]:
                self.treeModel.append(group, [host["name"], host["host"], host["user"], host["pass"], host["port"], host["tunnel"], iconHost])
        self.treeServers.expand_all()

    def writeConfig(self): 
        global groups
        
        cp= ConfigParser.RawConfigParser( )
        cp.read( CONFIG_FILE + ".tmp" )
        
        cp.add_section("options")
        cp.set("options", "word-separators", conf.WORD_SEPARATORS)        
        cp.set("options", "buffer-lines", conf.BUFFER_LINES)
        cp.set("options", "confirm-exit", conf.CONFIRM_ON_EXIT)
        cp.set("options", "font-color", conf.FONT_COLOR)
        cp.set("options", "back-color", conf.BACK_COLOR)        
        
        i=1
        for grupo in groups:
            for host in groups[grupo]:
                section = "host " + str(i)
                cp.add_section(section)
                cp.set(section, "group", grupo)
                cp.set(section, "name", host["name"])
                cp.set(section, "host", host["host"])
                cp.set(section, "user", host["user"])
                cp.set(section, "pass", encrypt(os.getenv("USERNAME"), host["pass"]))
                cp.set(section, "port", host["port"])
                cp.set(section, "tunnel", host["tunnel"])
                i+=1
        f = open(CONFIG_FILE + ".tmp", "w")
        cp.write(f)
        f.close()
        os.rename(CONFIG_FILE + ".tmp", CONFIG_FILE)
        
    def on_tab_focus(self, widget, *args): 
        if isinstance(widget, vte.Terminal):
            self.current = widget
        
    def split_notebook(self, direction):        
        csp = self.current.get_parent() if self.current!=None else None
        cnb = csp.get_parent() if csp!=None else None
        
        #Separar solo si hay mas de 2 tabs en el notebook actual
        if csp!=None and cnb.get_n_pages()>1:
            #Crear un hpaned, en el hijo 0 dejar el notebook y en el hijo 1 el nuevo notebook
            #El nuevo hpaned dejarlo como hijo del actual parent
            hp = gtk.HPaned() if direction==HSPLIT else gtk.VPaned()
            nb = gtk.Notebook()
            nb.set_group_id(11)
            nb.connect('button_press_event', self.on_double_click, None)
            nb.connect('page_removed', self.on_page_removed)
            nb.connect("page-added", self.on_page_added)
            
            cp  = cnb.get_parent()

            #if direction==HSPLIT:
            #    cnb.set_size_request(cnb.allocation.width/2, -1)
            #else:
            #    cnb.set_size_request(-1, cnb.allocation.height/2)
            cnb.set_size_request(cnb.allocation.width/2, cnb.allocation.height/2)
            
            cp.remove(cnb)
            cp.add(hp)
            hp.add1(cnb)
                                   
            text = cnb.get_tab_label(csp).get_text()
            
            csp.reparent(nb)                  
            csp = nb.get_nth_page(0)
            tab = NotebookTabLabel(text, nb, csp )
            nb.set_tab_label(csp, tab_label=tab)                       
            nb.set_tab_reorderable(csp, True)
            nb.set_tab_detachable(csp, True)
            
            hp.add2(nb)
            nb.show()
            hp.show()
            hp.queue_draw()
            self.current = cnb.get_nth_page(cnb.get_current_page()).get_children()[0]

    def find_notebook(self, widget, exclude=None):
        if widget!=exclude and isinstance(widget, gtk.Notebook):
            return widget
        else:
            if not hasattr(widget, "get_children"):
                return None
            for w in widget.get_children():
                wid = self.find_notebook(w, exclude)
                if wid!=exclude and isinstance(wid, gtk.Notebook):
                    return wid
            return None


    def on_page_removed(self, widget, *args):
        self.count-=1
        
        if widget.get_n_pages()==0:
            #eliminar el notebook solo si queda otro notebook y no quedan tabs en el actual            
            paned = widget.get_parent()            
            if paned==None or paned==self.hpMain:
                return
            container = paned.get_parent()
            save = paned.get_child2() if paned.get_child1()==widget else paned.get_child1()    
            container.remove(paned)
            paned.remove(save)
            container.add(save)
            if widget == self.nbConsole:                
                if isinstance(save, gtk.Notebook):
                    self.nbConsole = save
                else:
                    self.nbConsole = self.find_notebook(save)


    def on_page_added(self, widget, *args):        
        self.count+=1
    #-- Wmain custom methods }

    #-- Wmain.on_wMain_destroy {
    def on_wMain_destroy(self, widget, *args):        
        self.writeConfig()
        gtk.main_quit()
    #-- Wmain.on_wMain_destroy }

    #-- Wmain.on_wMain_delete_event {
    def on_wMain_delete_event(self, widget, *args):
        if conf.CONFIRM_ON_EXIT and self.count>0 and msgconfirm("Hay %d consolas abiertas, confirma que desea salir?" % (self.count) ) != gtk.RESPONSE_OK:
            return True
    #-- Wmain.on_wMain_delete_event }

    #-- Wmain.on_salir1_activate {
    def on_salir1_activate(self, widget, *args):
        self.writeConfig()
        gtk.main_quit()
    #-- Wmain.on_salir1_activate }

    #-- Wmain.on_acerca_de1_activate {
    def on_acerca_de1_activate(self, widget, *args):
        w_about = Wabout()              
    #-- Wmain.on_acerca_de1_activate }

    #-- Wmain.on_double_click {
    def on_double_click(self, widget, event, *args):
        if event.type in [gtk.gdk._2BUTTON_PRESS, gtk.gdk._3BUTTON_PRESS]:
            self.addTab(widget if isinstance(widget, gtk.Notebook) else self.nbConsole, 'local', '', '', '', '','')
    #-- Wmain.on_double_click }

    #-- Wmain.on_btnConnect_clicked {
    def on_btnConnect_clicked(self, widget, *args):
        if self.treeServers.get_selection().get_selected()[1]!=None:
            if not self.treeModel.iter_has_child(self.treeServers.get_selection().get_selected()[1]):
                self.on_tvServers_row_activated(self.treeServers)
            else:
                group = self.treeModel.get_value(self.treeServers.get_selection().get_selected()[1],0)
                for h in groups[group]:                    
                    self.addTab(self.nbConsole, h["name"], h["host"], h["user"], h["pass"], h["port"], h["tunnel"])
    #-- Wmain.on_btnConnect_clicked }

    #-- Wmain.on_btnAdd_clicked {
    def on_btnAdd_clicked(self, widget, *args):
        group=""
        if self.treeServers.get_selection().get_selected()[1]!=None:
            if not self.treeModel.iter_has_child(self.treeServers.get_selection().get_selected()[1]):
                group = self.treeModel.get_value(self.treeModel.iter_parent(self.treeServers.get_selection().get_selected()[1]),0)
            else:
                group = self.treeModel.get_value(self.treeServers.get_selection().get_selected()[1],0)
        wHost = Whost()
        wHost.init(group)
        self.updateTree()
    #-- Wmain.on_btnAdd_clicked }

    #-- Wmain.on_bntEdit_clicked {
    def on_bntEdit_clicked(self, widget, *args):
        if self.treeServers.get_selection().get_selected()[1]!=None and not self.treeModel.iter_has_child(self.treeServers.get_selection().get_selected()[1]):
            group = self.treeModel.get_value(self.treeModel.iter_parent(self.treeServers.get_selection().get_selected()[1]),0)
            server = self.treeModel.get_value(self.treeServers.get_selection().get_selected()[1],0)
            host = self.treeModel.get_value(self.treeServers.get_selection().get_selected()[1],1)
            user = self.treeModel.get_value(self.treeServers.get_selection().get_selected()[1],2)
            password = self.treeModel.get_value(self.treeServers.get_selection().get_selected()[1],3)
            port = self.treeModel.get_value(self.treeServers.get_selection().get_selected()[1],4)
            tunnel = self.treeModel.get_value(self.treeServers.get_selection().get_selected()[1],5)
            wHost = Whost()
            wHost.init(group, server, host, user, password, port, tunnel)
            self.updateTree()
    #-- Wmain.on_bntEdit_clicked }

    #-- Wmain.on_btnDel_clicked {
    def on_btnDel_clicked(self, widget, *args):
        if self.treeServers.get_selection().get_selected()[1]!=None:
            if not self.treeModel.iter_has_child(self.treeServers.get_selection().get_selected()[1]):
                #Eliminar solo el nodo
                name = self.treeModel.get_value(self.treeServers.get_selection().get_selected()[1],0)
                if msgconfirm("Confirma que desea eliminar el host [%s]?" % (name) ) == gtk.RESPONSE_OK:
                    group = self.treeModel.get_value(self.treeModel.iter_parent(self.treeServers.get_selection().get_selected()[1]),0)                
                    for h in groups[group]:
                        if h["name"] == name:
                            groups[group].remove(h)
                            break
                    self.updateTree()
            else:
                #Eliminar todo el grupo
                group = self.treeModel.get_value(self.treeServers.get_selection().get_selected()[1],0)
                if msgconfirm("Confirma que desea eliminar todos los hosts del grupo [%s]?" % (group) ) == gtk.RESPONSE_OK:                                
                    del groups[group]
                    self.updateTree()
                            
    #-- Wmain.on_btnDel_clicked }

    #-- Wmain.on_btnHSplit_clicked {
    def on_btnHSplit_clicked(self, widget, *args):
        self.split_notebook(HSPLIT)
    #-- Wmain.on_btnHSplit_clicked }

    #-- Wmain.on_btnVSplit_clicked {
    def on_btnVSplit_clicked(self, widget, *args):
        self.split_notebook(VSPLIT)
    #-- Wmain.on_btnVSplit_clicked }

    #-- Wmain.on_btnUnsplit_clicked {
    def on_btnUnsplit_clicked(self, widget, *args):
        wid = self.find_notebook(self.hpMain, self.nbConsole)
        while wid!=None:
            #Mover los tabs al notebook principal           
            while wid.get_n_pages()!=0:
                csp = wid.get_nth_page(0)
                text = wid.get_tab_label(csp).get_text()
                csp.reparent(self.nbConsole)
                csp = self.nbConsole.get_nth_page(self.nbConsole.get_n_pages()-1)
                tab = NotebookTabLabel(text, self.nbConsole, csp )
                self.nbConsole.set_tab_label(csp, tab_label=tab)                       
                self.nbConsole.set_tab_reorderable(csp, True)
                self.nbConsole.set_tab_detachable(csp, True)
            wid = self.find_notebook(self.hpMain, self.nbConsole)
    #-- Wmain.on_btnUnsplit_clicked }

    #-- Wmain.on_btnConfig_clicked {
    def on_btnConfig_clicked(self, widget, *args):
        wConfig = Wconfig()
    #-- Wmain.on_btnConfig_clicked }

    #-- Wmain.on_tvServers_row_activated {
    def on_tvServers_row_activated(self, widget, *args):                
        if not self.treeModel.iter_has_child(widget.get_selection().get_selected()[1]):            
            server = self.treeModel.get_value(widget.get_selection().get_selected()[1],0)
            host = self.treeModel.get_value(widget.get_selection().get_selected()[1],1)
            user = self.treeModel.get_value(widget.get_selection().get_selected()[1],2)
            password = self.treeModel.get_value(widget.get_selection().get_selected()[1],3)
            port = self.treeModel.get_value(widget.get_selection().get_selected()[1],4)
            tunnel = self.treeModel.get_value(widget.get_selection().get_selected()[1],5)            
            self.addTab(self.nbConsole, server, host, user, password, port, tunnel)
    #-- Wmain.on_tvServers_row_activated }


class Whost(SimpleGladeApp):

    def __init__(self, path="gnome-connection-manager.glade",
                 root="wHost",
                 domain=app_name, **kwargs):
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)
        
        self.treeModel = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_STRING)
        self.treeTunel.set_model(self.treeModel)
        column = gtk.TreeViewColumn("Local", gtk.CellRendererText(), text=0)
        self.treeTunel.append_column( column )        
        column = gtk.TreeViewColumn("Host", gtk.CellRendererText(), text=1)
        self.treeTunel.append_column( column )        
        column = gtk.TreeViewColumn("Remoto", gtk.CellRendererText(), text=2)
        self.treeTunel.append_column( column )        


    #-- Whost.new {
    def new(self):
        global groups
        
        self.cmbGroup = self.get_widget("cmbGroup")
        self.txtName = self.get_widget("txtName")
        self.txtHost = self.get_widget("txtHost")
        self.txtUser = self.get_widget("txtUser")
        self.txtPass = self.get_widget("txtPassword")
        self.txtPort = self.get_widget("txtPort")
        self.cmbGroup.get_model().clear()
        for group in groups:
            self.cmbGroup.get_model().append([group])
        self.isNew = True
        
        self.txtLocalPort = self.get_widget("txtLocalPort")
        self.txtRemoteHost = self.get_widget("txtRemoteHost")
        self.txtRemotePort = self.get_widget("txtRemotePort")
        self.treeTunel = self.get_widget("treeTunel")
        
    #-- Whost.new }

    #-- Whost custom methods {
    def init(self, *args):        
        if len(args)>1:
            try:
                self.cmbGroup.get_child().set_text(args[0])
                self.oldGroup = args[0]
                self.txtName.set_text(args[1])
                self.oldName = args[1]
                self.txtHost.set_text(args[2])
                self.txtUser.set_text(args[3])
                self.txtPass.set_text(args[4])
                self.txtPort.set_text(args[5])
                for t in args[6].split(","):
                    if t!="":
                        tun = t.split(":")
                        tun.append(t)
                        self.treeModel.append(  tun )
            except:                
                pass
            self.isNew = False
        else:
            if len(args)==1:
                self.cmbGroup.get_child().set_text(args[0])
            self.isNew = True
    #-- Whost custom methods }

    #-- Whost.on_cancelbutton1_clicked {
    def on_cancelbutton1_clicked(self, widget, *args):
        self.get_widget("wHost").destroy()
    #-- Whost.on_cancelbutton1_clicked }


    #-- Whost.on_okbutton1_clicked {
    def on_okbutton1_clicked(self, widget, *args):
        group = self.cmbGroup.get_active_text().strip()
        name = self.txtName.get_text().strip()
        host = self.txtHost.get_text().strip()
        user = self.txtUser.get_text().strip()
        password = self.txtPass.get_text().strip()
        port = self.txtPort.get_text().strip()
        tunnel=""
        for x in self.treeModel:
            tunnel = '%s,%s' % (x[3], tunnel)
        tunnel=tunnel[:-1]
        
        #Validar datos
        if group=="" or name=="" or host=="":
            msgbox("Los campos grupo, nombre y host son obligatorios")
            return
        
        if not (port and port.isdigit() and 1 <= int(port) <= 65535):
            msgbox("Puerto invalido")
            return
            
        try:
            #Guardar                
            if not groups.has_key(group):
                groups[group]=[]   
            
            if self.isNew:
                for h in groups[group]:
                    if h["name"] == name:
                        msgbox("El nombre [%s] ya existe para el grupo [%s]" % (name, group))
                        return
                groups[group].append( { "name": name, "host": host, "user": user, "pass": password, "port": port, "tunnel": tunnel } )
            else:
                if self.oldGroup!=group:
                    #revisar que no este el nombre en el nuevo grupo
                    if not groups.has_key(group):
                        groups[group] = [ { "name": name, "host": host, "user": user, "pass": password, "port": port, "tunnel": tunnel } ]
                    else:
                        for h in groups[group]:
                            if h["name"] == name:
                                msgbox("El nombre [%s] ya existe para el grupo [%s]" % (name, group))
                                return
                        groups[group].append( { "name": name, "host": host, "user": user, "pass": password, "port": port, "tunnel": tunnel } )
                        for h in groups[self.oldGroup]:
                            if h["name"] == self.oldName:
                                groups[self.oldGroup].remove(h)
                else:
                    if self.oldName!=name:                        
                        for h in groups[self.oldGroup]:
                            if h["name"] == name:
                                msgbox("El nombre [%s] ya existe para el grupo [%s]" % (name, group))
                                return
                        for h in groups[self.oldGroup]:
                            if h["name"] == self.oldName:
                                h["name"] = name
                                h["host"] = host
                                h["user"] = user
                                h["pass"] = password   
                                h["port"] = port
                                h["tunnel"] = tunnel
                                break
                    else:
                        for h in groups[self.oldGroup]:
                            if h["name"] == self.oldName:
                                h["name"] = name
                                h["host"] = host
                                h["user"] = user
                                h["pass"] = password
                                h["port"] = port
                                h["tunnel"] = tunnel
                                break
        except:
            msgbox("Error al guardar el host. Descripcion [%s]" % (sys.exc_info()[1]))            
        
        global wMain
        wMain.updateTree()
        
        self.get_widget("wHost").destroy()
    #-- Whost.on_okbutton1_clicked }

    #-- Whost.on_btnAdd_clicked {
    def on_btnAdd_clicked(self, widget, *args):                
        local = self.txtLocalPort.get_text().strip()
        host = self.txtRemoteHost.get_text().strip()        
        remote = self.txtRemotePort.get_text().strip()
        
        #Validar datos del tunel
        if host == "":
            msgbox("Debe ingresar host remoto")
            return
            
        for x in self.treeModel:
            if x[0] == local:
                msgbox("Puerto local ya fue asignado")
                return
                        
        tunel = self.treeModel.append( [local, host, remote, '%s:%s:%s' % (local, host, remote) ] )
        
    #-- Whost.on_btnAdd_clicked }

    #-- Whost.on_btnDel_clicked {
    def on_btnDel_clicked(self, widget, *args):
        if self.treeTunel.get_selection().get_selected()[1]!=None:
            self.treeModel.remove(self.treeTunel.get_selection().get_selected()[1])
    #-- Whost.on_btnDel_clicked }


class Wabout(SimpleGladeApp):

    def __init__(self, path="gnome-connection-manager.glade",
                 root="wAbout",
                 domain=app_name, **kwargs):
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)
        self.wAbout.set_icon_from_file("icon.png")
    #-- Wabout.new {
    def new(self):       
        self.wAbout.set_name(app_name)
        self.wAbout.set_version(app_version)
        self.wAbout.set_website(app_web)    
    #-- Wabout.new }

    #-- Wabout custom methods {
    #   Write your own methods here
    #-- Wabout custom methods }

    #-- Wabout.on_wAbout_close {
    def on_wAbout_close(self, widget, *args):
        self.wAbout.destroy()
    #-- Wabout.on_wAbout_close }


class Wconfig(SimpleGladeApp):

    def __init__(self, path="gnome-connection-manager.glade",
                 root="wConfig",
                 domain=app_name, **kwargs):
        path = os.path.join(glade_dir, path)
        SimpleGladeApp.__init__(self, path, root, domain, **kwargs)

    #-- Wconfig.new {
    def new(self):
        #Agregar controles
        self.tblGeneral = self.get_widget("tblGeneral")
        self.btnFColor = self.get_widget("btnFColor")
        self.btnBColor = self.get_widget("btnBColor")
        self.dlgColor = None
        
        self.tblGeneral.rows = 0
        self.addParam("Separador de Palabras", "conf.WORD_SEPARATORS", str)
        self.addParam("Tamaño del buffer", "conf.BUFFER_LINES", int, 1, 1000000)
        self.addParam("Confirmar al salir", "conf.CONFIRM_ON_EXIT", bool)  
        
        if len(conf.FONT_COLOR)==0:
            self.get_widget("chkDefaultColors").set_active(True)
            self.btnFColor.set_sensitive(False)
            self.btnBColor.set_sensitive(False)
            fcolor="#FFFFFF"
            bcolor="#000000"
        else:
            self.get_widget("chkDefaultColors").set_active(False)
            self.btnFColor.set_sensitive(True)
            self.btnBColor.set_sensitive(True)
            fcolor=conf.FONT_COLOR
            bcolor=conf.BACK_COLOR            
 
        self.btnFColor.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(fcolor))
        self.btnFColor.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.Color(fcolor))
        self.btnBColor.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color(bcolor))
        self.btnBColor.modify_bg(gtk.STATE_PRELIGHT, gtk.gdk.Color(bcolor))
        self.btnFColor.selected_color=fcolor
        self.btnBColor.selected_color=bcolor
    #-- Wconfig.new }

    #-- Wconfig custom methods {
    def addParam(self, name, field, type, *args):
        x = self.tblGeneral.rows
        self.tblGeneral.rows += 1
        value = eval(field)
        if type==bool:
            obj = gtk.CheckButton()
            obj.set_label(name)
            obj.set_active(value)
            obj.set_alignment(0, 0.5)            
            obj.show()
            obj.field=field
            self.tblGeneral.attach(obj, 0, 2, x, x+1, gtk.EXPAND|gtk.FILL, 0)            
        elif type==int:            
            obj = gtk.SpinButton(climb_rate=10)
            if len(args)==2:
                obj.set_range(args[0], args[1])
            obj.set_increments(1, 10)
            obj.set_numeric(True)
            obj.set_value(value)                        
            obj.show()
            obj.field=field
            lbl = gtk.Label(name)
            lbl.set_alignment(0, 0.5)
            lbl.show()
            self.tblGeneral.attach(lbl, 0, 1, x, x+1, gtk.FILL, 0)
            self.tblGeneral.attach(obj, 1, 2, x, x+1, gtk.EXPAND|gtk.FILL, 0)
        else:            
            obj = gtk.Entry()
            obj.set_text(value)            
            obj.show()
            obj.field=field
            lbl = gtk.Label(name)
            lbl.set_alignment(0, 0.5)
            lbl.show()
            self.tblGeneral.attach(lbl, 0, 1, x, x+1, gtk.FILL, 0)
            self.tblGeneral.attach(obj, 1, 2, x, x+1, gtk.EXPAND|gtk.FILL, 0)
            
    def show_color_dialog(self, title, button):
        if self.dlgColor == None:
            self.dlgColor = gtk.ColorSelectionDialog(title)
        colorsel = self.dlgColor.colorsel
        colorsel.set_previous_color(gtk.gdk.Color(button.selected_color))
        colorsel.set_current_color(gtk.gdk.Color(button.selected_color))
        colorsel.set_has_palette(True)

        response = self.dlgColor.run()

        if response == gtk.RESPONSE_OK:
            button.selected_color = colorsel.get_current_color().to_string()
            button.modify_bg(gtk.STATE_NORMAL, colorsel.get_current_color())
            button.modify_bg(gtk.STATE_PRELIGHT, colorsel.get_current_color())
        self.dlgColor.hide()
    #-- Wconfig custom methods }

    #-- Wconfig.on_cancelbutton1_clicked {
    def on_cancelbutton1_clicked(self, widget, *args):
        self.get_widget("wConfig").destroy()
    #-- Wconfig.on_cancelbutton1_clicked }

    #-- Wconfig.on_okbutton1_clicked {
    def on_okbutton1_clicked(self, widget, *args):
        for obj in self.tblGeneral:
            if hasattr(obj, "field"):
                if isinstance(obj, gtk.CheckButton):
                    value = obj.get_active()
                elif isinstance(obj, gtk.SpinButton):
                    value = obj.get_value_as_int()
                else:
                    value = '"%s"' % (obj.get_text())
                exec("%s=%s" % (obj.field, value))
        
        if self.get_widget("chkDefaultColors").get_active():
            conf.FONT_COLOR=""
            conf.BACK_COLOR=""
        else:
            conf.FONT_COLOR = self.btnFColor.selected_color
            conf.BACK_COLOR = self.btnBColor.selected_color
        
        self.get_widget("wConfig").destroy()
    #-- Wconfig.on_okbutton1_clicked }

    #-- Wconfig.on_btnBColor_clicked {
    def on_btnBColor_clicked(self, widget, *args):
        self.show_color_dialog("Seleccione el color de fondo", self.btnBColor)
    #-- Wconfig.on_btnBColor_clicked }

    #-- Wconfig.on_btnFColor_clicked {
    def on_btnFColor_clicked(self, widget, *args):
        self.show_color_dialog("Seleccione el color de fondo", self.btnFColor)
    #-- Wconfig.on_btnFColor_clicked }

    #-- Wconfig.on_chkDefaultColors_toggled {
    def on_chkDefaultColors_toggled(self, widget, *args):
        self.btnFColor.set_sensitive(not widget.get_active())
        self.btnBColor.set_sensitive(not widget.get_active())
    #-- Wconfig.on_chkDefaultColors_toggled }




class NotebookTabLabel(gtk.HBox):
    '''Notebook tab label with close button.
    '''
    def __init__(self, title, owner_, widget_):
        gtk.HBox.__init__(self, False, 0)
        
        label = self.label = gtk.Label()
        label.set_alignment(0.0, 0.5)
        label.set_text(title)
        self.pack_start(label)
        label.show()
        
        close_image = gtk.image_new_from_stock(gtk.STOCK_CLOSE, gtk.ICON_SIZE_MENU)
        image_w, image_h = gtk.icon_size_lookup(gtk.ICON_SIZE_MENU)
        self.widget=widget_
        close_btn = gtk.Button()
        close_btn.set_relief(gtk.RELIEF_NONE)
        close_btn.connect('clicked', self.on_close_tab, owner_)
        close_btn.set_size_request(image_w+2, image_h+2)
        close_btn.add(close_image)
        self.pack_start(close_btn, False, False)
        close_btn.show_all()         
        self.show()
     
    def on_close_tab(self, widget, notebook, *args):
        page=notebook.page_num(self.widget)         
        notebook.remove_page(page)
        self.widget.destroy()

    def mark_tab_as_closed(self):
        self.label.set_markup("<span color='darkgray' strikethrough='true'>%s</span>" % (self.label.get_text()))
        
    def get_text(self):
        return self.label.get_text()

#-- main {

def main():
    w_main = Wmain()

    w_main.run()

if __name__ == "__main__":
    main()

#-- main }

